<template>
  <div class="row">
    <div class="col-md-12">
      <transition name="fade">
        <div v-if="ticket">
          <alert-error :form="form" :message="$t('invalid_form')"></alert-error>
          <b-card :header="$t('show_ticket')" header-tag="header" class="mb-2">
            <div class="panel-body chat">
              <ul>
                <li
                  v-for="reply in ticket.ticket_replies"
                  :key="reply.id"
                  :class="reply.user_id == user.id ? 'him' : 'me'"
                >
                  {{ reply.content }}
                </li>
              </ul>
            </div>
          </b-card>
          <b-card v-if="!ticket.closed_at">
            <form
              @submit.prevent="replyTicket"
              @keydown="form.onKeydown($event)"
            >
              <b-form-group
                id="content-group"
                :label="$t('reply_content')"
                label-for="content"
              >
                <b-form-textarea
                  id="content"
                  v-model="form.content"
                  required
                  :placeholder="$t('reply_content')"
                  :class="{ 'is-invalid': form.errors.has('content') }"
                  rows="10"
                  max-rows="15"
                ></b-form-textarea>
                <has-error :form="form" field="content" />
              </b-form-group>
              <b-button
                :disabled="!!ticket.closed_at"
                type="submit"
                variant="info"
                >{{ $t("reply_ticket") }}</b-button
              >
            </form>
          </b-card>
        </div>
      </transition>
    </div>
  </div>
</template>

<script>
import Form from "vform";
import { mapGetters } from "vuex";
import axios from "axios";

export default {
  scrollToTop: false,

  metaInfo() {
    return { title: this.$t("show_ticket") };
  },

  props: ["id"],

  data: () => ({
    form: new Form({
      content: ""
    }),
    ticket: null
  }),
  computed: {
    ...mapGetters({
      user: "auth/user"
    })
  },

  mounted() {
    this.getTicket();
  },

  methods: {
    async getTicket() {
      const { data } = await axios.get(route("shop.tickets.get", this.id));
      if (data) {
        this.ticket = data;
      }
    },

    async replyTicket() {
      const { data } = await this.form.post(
        route("shop.tickets.reply", this.id)
      );
      if (data.id) {
        this.$router.push({ name: "panel.tickets" });
      }
    }
  }
};
</script>
